using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;

namespace PopupTest
{
	public class MyPopupContainer : System.Windows.Forms.UserControl
	{
    private System.Windows.Forms.Button button1;
    private MyPopupControl _myPopupControl;
    private Syncfusion.Windows.Forms.PopupControlContainer _calendarPopUp;    
    public TextBoxWithPopup _txtDate;
    private bool _editMode;
		
    private System.ComponentModel.IContainer components;

		public MyPopupContainer()
		{
			InitializeComponent();
      MakeSurePopupCreated();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this._txtDate = new PopupTest.TextBoxWithPopup();
      this.button1 = new System.Windows.Forms.Button();
      this.components = new System.ComponentModel.Container();
      this.SuspendLayout();
      // 
      // _txtDate
      // 
      this._txtDate.FriendlyControl = null;
      this._txtDate.Location = new System.Drawing.Point(8, 8);
      this._txtDate.Name = "_txtDate";
      this._txtDate.PopupControlContainer = null;
      this._txtDate.PopupTextBox = null;
      this._txtDate.TabIndex = 0;
      this._txtDate.Text = "textBox1";
      // 
      // button1
      // 
      this.button1.Location = new System.Drawing.Point(112, 8);
      this.button1.Name = "button1";
      this.button1.TabIndex = 1;
      this.button1.Text = "button1";
      this.button1.Click += new System.EventHandler(this.button1_Click);
      // 
      // UserControl1
      // 
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.button1,
                                                                  this._txtDate});
      this.Name = "UserControl1";
      this.Size = new System.Drawing.Size(192, 40);
      this.ResumeLayout(false);

    }
		#endregion

    private bool MakeSurePopupCreated()
    {
      bool result = false;
      try
      {
        if (_calendarPopUp == null)
        {
          result = CreatePopupCalendar();
        }
        else
        {
          result = true;
        }
      }
      catch(Exception ex_)
      {
        MessageBox.Show(ex_.ToString());
      }
      return result;
    }

    private bool CreatePopupCalendar()
    {
      bool result = false;
      try
      {
        _calendarPopUp = new PopupControlContainer(components);
      
        _txtDate.PopupControlContainer = _calendarPopUp;

        _calendarPopUp.Location = new System.Drawing.Point(104, 40);
        _calendarPopUp.Name = "_calendarPopUp";
        _calendarPopUp.PopupParent = _txtDate;
        Controls.Add(_calendarPopUp);
        InitCalendar();
        result = true;
      }
      catch (Exception ex_) 
      {
        MessageBox.Show(ex_.ToString());
      }
      return result;
    }
    
    private void InitCalendar()
    {
      try
      {
        if (_myPopupControl == null)
        {
          _myPopupControl = new MyPopupControl();
      
          _calendarPopUp.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                                _myPopupControl});

          _calendarPopUp.TabStop = false;
        }
          
      }
      catch (Exception ex_) 
      {
        MessageBox.Show(ex_.ToString());
      }
    }

    private void button1_Click(object sender, System.EventArgs e)
    {
      _calendarPopUp.ShowPopup(Point.Empty);
    }

    protected override void OnEnter(EventArgs e)
    {      
      Activate();     
      base.OnEnter(e);
    }

    protected override void OnValidated(EventArgs e)
    {      
      if (_editMode)
        Deactivate();
      base.OnValidated(e);     
    }

    protected virtual void SetEditMode(bool on_)
    {
      try
      {        
        if (on_)
        {
          MakeSurePopupCreated();          
        }
        else if (_calendarPopUp != null)
        {
          //Using DisposePopupCalendar() directly is ok but using BeginInvoke causes the issue          
          //DisposePopupCalendar();
          BeginInvoke(new MethodInvoker(DisposePopupCalendar));
        }        
        _editMode = on_;
      }
      catch (Exception ex_) 
      {
        MessageBox.Show(ex_.ToString());
      }
    }

    public virtual void Deactivate()
    {
      SetEditMode(false);
    }

    public virtual void Activate()
    {     
      SetEditMode(true);
    }

    public void DisposePopupCalendar()
    {
      try
      {
        if (_calendarPopUp != null)
        {
          if (_calendarPopUp.IsShowing())
            _calendarPopUp.HidePopup(PopupCloseType.Done);
          if (_myPopupControl != null)
          {
            _myPopupControl.Dispose();           
            _calendarPopUp.Controls.Remove(_myPopupControl);
            _myPopupControl = null;
          }
          if (_txtDate != null)
            _txtDate.PopupControlContainer = null;
          Controls.Remove(_calendarPopUp);
          _calendarPopUp.Dispose();
          _calendarPopUp = null;
        }        
      }
      catch (Exception ex_) 
      {
        MessageBox.Show(ex_.ToString());
      }
    }
	}
}